﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _21AlgPalindromAnagram
{
    public partial class Form1 : Form
    {
        bool czyPalindrom(string slowo)
        {
            //ustaw poczatek i koniec granicy przegladania
            //znaków w słowie z lewej i prawej strony
            int L = 0, P = slowo.Length - 1;
            while (L<P)
            {
                //jak sie znaki nie zgadzają to zakańcz,
                //bo słowo nie jest palindromem
                if (slowo[L] != slowo[P]) return false;
                L++;
                P--;
            }
            return true;
        }
        bool czyAnagram(string slowo1, string slowo2)
        {
            //jezeli długości słów sa rózne to
            //nie słowa nie są anagramami
            if (slowo1.Length != slowo2.Length) return false;
            //algorytm działa wykorzystując pozycję
            //znaków w kodzie ASCII, wszystkich jest 256
            //utwórz tablice dla sum występowania indeksów znaków
            int[] tabSum = new int[256];
            //zeruj sumy
            for (int i = 0; i < 256; i++)tabSum[i]=0;
            //sumuj wystąpienie znaków w pierwszym slowie
            for (int i = 0; i < slowo1.Length; i++) tabSum[slowo1[i]]++;
            //odejmi wystapienie znaku gdy wystapi w drugim slowie
            for (int i = 0; i < slowo2.Length; i++) tabSum[slowo2[i]]--;
            //sprawdx czy sie wyzerowały wystąpienia,
            //jezeli nie, to słowa nie są anagramami
            for(int i=0; i < 256; i++)
                if(tabSum[i]!=0) return false;
            return true;
        }
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1) return;
            if (czyPalindrom(textBox1.Text))
                MessageBox.Show(
                    "Podane słowo jest palindromem",
                    "Czy palindrom?",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );
            else MessageBox.Show(
                    "Podane słowo nie jest palindromem",
                    "Czy palindrom?",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1 || textBox2.Text.Length < 1) return;
            if (czyAnagram(textBox1.Text, textBox2.Text))
                MessageBox.Show(
                    "Podane słowa są anagramami",
                    "Czy anagram?",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );
            else MessageBox.Show(
                    "Podane słowo nie są anagramami",
                    "Czy anagram?",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Information
                    );
        }
    }
}
